package org.hibernate.domain;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

@Entity
@Table(name = "purchase_organizations")
public class PurchaseOrg implements Serializable {

	private static final long serialVersionUID = 1916348931527999262L;

	@Id
	@GeneratedValue
	@Column(name = "PURCHASE_ORG_ID", nullable = false, updatable = false)
	private Long id;
	
	@Column(name = "PURCHASE_ORG_NAME", length = 80, nullable = false)
	private String name;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CUSTOMER_ID", referencedColumnName = "CUSTOMER_ID", nullable = false, updatable = false)
	private Customer customer;
	
	@ManyToMany(fetch = FetchType.LAZY)
	@JoinTable(name = "purchase_organization_facilities", joinColumns = @JoinColumn(name = "PURCHASE_ORG_ID"), inverseJoinColumns = @JoinColumn(name = "FACILITY_ID"))
	private List<Facility> facility;
	
	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the customer
	 */
	public Customer getCustomer() {
		return customer;
	}

	/**
	 * @param customer the customer to set
	 */
	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	/**
	 * @return the facility
	 */
	public List<Facility> getFacility() {
		return facility;
	}

	/**
	 * @param facility the facility to set
	 */
	public void setFacility(List<Facility> facility) {
		this.facility = facility;
	}

	/**
     * {@inheritDoc}
     */
    @Override
    public int hashCode() {
        return new HashCodeBuilder()
        	.append(id)
        	.toHashCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean equals(Object object) {
        if (!(object instanceof PurchaseOrg)) return false;
        PurchaseOrg other = (PurchaseOrg) object;
        return new EqualsBuilder()
        	.append(id, other.id)
        	.isEquals();
    }
    
}
